import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import { environment } from './../../../../environments/environment';

@Component({
    selector: 'header',
    templateUrl: './header.component.html',
    styleUrls: ['./header.component.scss']
})
export class HeaderComponent implements OnInit {
    public menus: Array<any> = [];
    public userName: string;
    public isLoggedIn: boolean = false;
    public title: string = environment.title

    constructor(
        private router: Router,
        private auth: AuthDecode,
        private authService: AuthService
    ) { }

    ngOnInit(): void {
        this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameEN;
        this.isLoggedIn = this.authService.isAuthenticated();
    }

    logOut() {
        this.authService.clearToken();
        this.router.navigate(['/'])
    }

    changePwd() {
        this.router.navigate(['/','changepwd'])
    }

    UserInfo() {

    }

}
