import { Component, Inject } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
    templateUrl: './info-modal.component.html',
    styleUrls: ['./modal.component.scss']
})
export class InfoModalComponent {

    public text: string;
    public buttons: any[];

    constructor(
        private dialogRef: MatDialogRef<InfoModalComponent>,
        @Inject(MAT_DIALOG_DATA) public dialogData: any
    ) { }

    ngOnDestroy() {
        setTimeout(() => {
            this.dialogRef ? this.dialogRef.close() : null;
        }, 100)
    }

    ngOnInit() {
        this.text = this.dialogData.text
        this.buttons = this.dialogData.actionButtons;
    }
}