import { Injectable, Optional } from '@angular/core';
import { JwtHelperService } from '@auth0/angular-jwt';
import { AuthService } from './auth-service.service';
import { HttpService } from './http.service';
import { Router } from '@angular/router';

@Injectable()
export class AuthDecode {
    private auth: AuthService;

    constructor(
        private jwtHelper: JwtHelperService,
        private router: Router,
        @Optional() private http: HttpService
    ) {
        this.auth = new AuthService(this.jwtHelper, this.router, this.http);
    }

    getDetail(checkAuth: boolean = true) {
        var token = localStorage.getItem("jwtToken") || '';

        if (checkAuth && this.auth.isAuthenticated()) {
            return this.jwtHelper.decodeToken(token);
        } else if(!checkAuth) {
            return this.jwtHelper.decodeToken(token);
        }

        return null;
    }
}