import { Component, OnInit,ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { convertMetaToOutput } from '@angular/compiler/src/render3/util';

@Component({
  selector: 'SNPE031_M',
  templateUrl: './SNPE031_M.component.html',
  styleUrls: ['./SNPE031_M.component.css']
})



export class SNPE031_MComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    public global: Globals,
    private auth: AuthDecode,
    private viewref: ViewContainerRef,
    private modal: ModalService,
  ) { }


  public headerList: any;

  public data: any = {};

  public tableData: any = [];
  public MainDatatable: any;
  public dataList: any;
  public displayedColumns: string[] = [];
  public isCustomContent: boolean = false;
  public SelectList: any;
  public IsSearch: any = true;
  public IsEdit: any = false;
  public IsAdd: any = false;
  public IsSaved = false;
  public IsCancel : boolean = true;
  public params: any = {
    DOCUMENT_NO: null,
    VENDOR_CODE: null,
    INVOICE_NO: null
  }

  public ConfigDocNo: any = {
    ColName: "LOOKUP_DOC",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: false
  }

  public ConfigDocS: any = {
    ColName: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigVendorS: any = {
    ColName: "LOOKUP_VENDOR",
    ColValue: "VENDOR_CODE",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR",
    PlaceholderText: "Select Vendor Code",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetVendor",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigInvS: any = {
    ColName: "INVOICE_NO",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: false,
    SourceParams : {
      VENDOR_CODE : null
    }
  }

  public ConfigInv: any = {
    ColName: "INV_LOOKUP",
    PlaceholderText: "Select Invoice No",
    SourceController: "AC",
    SourceMethodName: "SNPE031_M_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: false,
    SourceParams : {
      VENDOR_CODE : null
    }
  }



  ngOnInit() {
    this.data = {};
    this.data.CREATE_DATE = new Date();
    //this.ConfigInv.SourceParams = { VENDOR_CODE: "" };
    this.data.DOCUMENT_DATE = new Date();

  }

  Edit(P_data) {
    console.log(P_data)
    this.data = P_data;
    //this.data.TOTAL_RECEIVE_QTY = this.data.TOTAL_QTY;
    //this.data.TOTAL_RECEIVE_NET_B = this.data.TOTAL_NET_B;
    this.IsSearch = false;
    this.IsEdit = true;
    this.IsAdd = false;
    this.IsCancel = false;
    
  }
  AddNew() {
    this.IsSaved = false;
    this.IsSearch = false;
    this.IsEdit = false;
    this.IsAdd = true;
    this.ngOnInit();
    this.tableData = [];
    this.tableData = [...this.tableData, { 'EDIT': 'ADD', 'SEQ': '' }];
  }

  GetTotalRecieve(){
    this.http.get("AC","SNPE031_M_GetTotalRecieve",this.data.VENDOR_CODE,this.data.REF_INV_NO)
    .subscribe(res =>{
        this.data.TOTAL_RECEIVE_QTY = this.data.TOTAL_QTY - res.Table[0].TOTAL_RECEIVE_QTY;
        this.data.TOTAL_RECEIVE_NET_B = this.data.TOTAL_NET_B - res.Table[0].TOTAL_RECEIVE_NET_B;
        console.log(res)
    })
  }

  GetPart(evt, data) {
    for (var i = 0; i < this.tableData.length; i++) {
      if (this.tableData[i].SEQ === data.SEQ) {
        this.tableData[i].ACCEPT_PART_NO = evt.ACCEPT_PART_NO;
        this.tableData[i].ORDER_PART_NO = evt.ORDER_PART_NO;
        this.tableData[i].PO_NO = evt.PO_NO;
        this.tableData[i].QUANTITY = evt.QUANTITY;
        this.tableData[i].UNIT_PRICE = evt.UNIT_PRICE;
        this.tableData[i].AMOUNT = evt.AMOUNT;
        this.tableData[i].ORDER_QTY = evt.ORDER_QTY;
        this.tableData[i].ITEM = evt.ITEM;
        this.tableData[i].SUB_ITEM_NO = evt.SUB_ITEM_NO;
        break;
      }
    }
  }

  GetDocNo(evt, t) {
    if (t === "s") {
      this.params.DOCUMENT_NO = evt.DOCUMENT_NO;
    }
    if (t === "a") {
      this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
      this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    }
  }
  GetVendor(evt, t) {
    if (t === "s") {
      this.params.VENDOR_CODE = evt;
      this.ConfigInv.SourceParams = { VENDOR_CODE: evt.VENDOR_CODE };
    }
    if (t === "a") {
      this.data = {};
      this.data.DOCUMENT_DATE = new Date();
      this.data.VENDOR_CODE = evt.VENDOR_CODE;
      this.data.VENDOR_NAME = evt.VENDOR_NAME_TH;
      this.data.VENDOR_TYPE = evt.VENDOR_TYPE     
     
    }

    this.ConfigInv.SourceParams.VENDOR_CODE = evt.VENDOR_CODE;
      this.ConfigInvS.SourceParams.VENDOR_CODE = evt.VENDOR_CODE;
  }
  GetInv(evt, t) {
    //console.log(evt)
    if (t === "s") {
      this.params.INVOICE_NO = evt;
    }
    if (t === "a") {

      if(!this.data.VENDOR_CODE){
        this.modal.warning("Please input vendor code",this.viewref)
      }

      if(!evt.INVOICE_NO && this.data.VENDOR_CODE){
        this.modal.warning("No data please re check vendor code or invice no",this.viewref)
      }
      
      //console.log('evt',evt)
      this.data.REF_INV_NO = evt.INVOICE_NO;
      this.data.REF_INV_DATE = evt.INVOICE_DATE;
      this.data.INV_STATUS = evt.TYPE_NAME_EN;
      //this.data.TOTAL_QTY = evt.TOT_QTY;
      //this.data.TOTAL_NET_B = evt.TOT_AMT_IMPORT;
      this.data.TOTAL_QTY = evt.BAL_QTY;
      this.data.TOTAL_NET_B = evt.BAL_COST_REC;
      this.data.FOUND_51_53 = evt.FOUND_51_53;
    }
  }

  Search() {
    console.log(this.params)
    this.http.post("AC", "SNPE031_M_GetList", this.params)
      .subscribe(res => {
        this.MainDatatable = res.Table;
      });

  }
  BackToGrid() {
    this.IsSearch = true;
  }

  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }

  ToShelve() {
    
    this.modal.confirm('Do you want to save change you have made?', this.viewref, this.ConfirmToShelve)
  }

  ConfirmToShelve = () => {
    this.http.post("AC", "SNPE031_M_ToShelve", this.data)
      .subscribe(res => {

        console.log(res,'ressssssssss')

        if(res.Table[0].STATUS == 'DONE'){
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.IsSaved = true;
          this.data.DOCUMENT_NO = res.Table[0].DOCUMENT_NO;
          this.data.DOCUMENT_DATE = res.Table[0].DOCUMENT_DATE;
          this.data.TOTAL_RECEIVE_QTY = res.Table[0].TOTAL_QTY ;
          this.data.TOTAL_RECEIVE_NET_B = res.Table[0].TOTAL_NET_B ;
          this.data.LAST_UPD_DATE = new Date();
          this.data.UPDATE_BY_NAME = this.global.GetTokenDetail("ssNameEN");
        }else if(res.Table[0].STATUS == 'PRICE_ERROR'){
          this.modal.error('Not allow to recieve part !!. Recieve Qty : A not equal to Invoice Qty :B or Recieve Amount :A not equal to Invoice Amount :B,' + ':A : '+ res.Table[0].TRH_QTY + ',' + res.Table[0].TRH_NET_AMT_B + ',' +':B : ' + res.Table[0].INH_QTY + ',' + res.Table[0].INH_NET_AMT_B
          , this.viewref,()=>{},{'width':'650px','height':'350px'});
        }else if(res.Table[0].STATUS == 'UNCONFIRM'){
          this.modal.warning("There is document no." + ' '+ res.Table[0].MESSAGE +' ' +"waiting to confirm. Please confirm before shelving the rest.",this.viewref)
        }else{
          this.modal.error('Found an error, please contract support team', this.viewref);
        }
        
      },(err) =>{
        this.modal.error('Found an error, please contract support team', this.viewref);
      });
  }

  Cancel() {
    this.modal.confirm('Are you sure to cancel this document?', this.viewref, this.ConfirmCancel)

  }

  ConfirmCancel = () => {
    this.data.LAST_UPD_PGM = 'SNPE031_M'
    this.http.post("AC", "SNPE031_M_Cancel", this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.IsSaved = false;
          this.IsCancel = true;
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      },(err) => {
        this.modal.error(err.message, this.viewref);
      });
  }

  
}


