import { Component, OnInit, ViewContainerRef, ChangeDetectorRef, ViewChild } from '@angular/core'
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';
import { getuid } from 'process';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { flatMap } from 'rxjs/operators';

@Component({

  selector: 'snse041_M',
  templateUrl: './SNSE041_M.component.html',
  styleUrls: ['./SNSE041_M.component.css']
})

export class SNSE041_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal : ModalService,
    private viewref : ViewContainerRef,
    private changeRef: ChangeDetectorRef,
    private global : Globals,
    private auth: AuthDecode,
  ) { }

  public CustomerList: any;
  public tableData: any = [];
  public ParamsHead : any = {};

  public ConfigPartNo: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      DOCUMENT_TYPE: null,
      DOCUMENT_NO: null,
      DOCUMENT_TYPE_H: null,
    }
  }

  public ConfigPartNo2: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      DOCUMENT_TYPE: null,
      DOCUMENT_NO: null,
    }
  }


  public ConfigDoctype: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Document Type",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetDoctype",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }

  
  public ConfigRefDoctype: any = {
    ColName: "DOCUMENT_TYPE",
    ColValue: "DOCUMENT_TYPE",
    PlaceholderText: "Select Ref Document Type",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetRefDoctype",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true,
  }

  public ConfigRefDocNo: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Ref Document No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetRefDocNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 5,
    UpperCase: true,
    SourceParams: {
      REF_DOC_TYPE: null
    }
  }


  public ConfigCustomer: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Customer Code",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
  }

  public ConfigBranch: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Branch",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetBranchCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      CUSTOMER_CODE: null
    }
  }

  public ConfigReason: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Reason Code",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetReason",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
  }

  public ConfigOrder: any = {
    ColName: "ORDER_NO",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetOrder",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      REF_DOC_TYPE: null,
      REF_DOC_NO: null,
      ORDER_PART_NO : null
    }
  }

  public ConfigDocNo: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNSE041_M_GetDocNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 5,
    UpperCase: true,
    SourceParams: {
      DOC_TYPE: null
    }
  }
  

  @ViewChild("doctypeauto", { static: true }) doctypeauto: AutoCompleteQueryComponent;
  public oldValue : any;
  public QtyOldValue : any;
  public DiscountOldValue : any;
  public tempTable : any = [];
  public Saved : boolean = false;
  public IsAdd : boolean = false;
  public ParamSearch : any = {};
  public tableSearch : any = [];
  public IsEdit : boolean = false;
  public IsSearch : boolean = true;
  public tempDocDate : any;
  public hideCols: Array<string> = []
  public data : any ={}
  ngOnInit() {
   
    this.CreateDetailRow(0);
    this.ParamsHead.DOCUMENT_NO = 'AUTO';
    this.ParamsHead.RETURN_BAL = 0

    this.http.GetSystemDate()
    .subscribe(res =>{  
      this.tempDocDate = res    
    })

    
  }

  Search(){


    if(this.ParamSearch.DOCUMENT_NO && !this.ParamSearch.DOCUMENT_TYPE){
      this.ParamSearch.DOCUMENT_TYPE = this.ParamSearch.DOCUMENT_NO.substring(0,2);
    }
    
    this.http.post("AC","SNSE041_M_GetHeaderList",{DOC_NO : this.ParamSearch.DOCUMENT_NO,DOC_TYPE : this.ParamSearch.DOCUMENT_TYPE})
    .subscribe(res =>{
      //console.log(res)
      this.tableSearch = res.Table
    })
  }


  New(){
    this.ParamsHead = {}
    this.tableData = [];
    this.Saved = false
    this.IsAdd = true;
    this.IsEdit = false;
    this.IsSearch = false;
    this.ParamsHead.DOCUMENT_NO = 'AUTO';
    this.ParamsHead.UPDATE_BY = this.auth.getDetail().ssNameEN;
    this.ParamsHead.UPDATE_DATE = new Date();
    this.ParamsHead.DOCUMENT_DATE = this.tempDocDate
    this.ParamsHead.ATTRIBUTE5 = '01'
    this.ParamsHead.DEST_PORT = 'GL'
    //this.CreateDetailRow(0);
  }

  Edit(data){
    console.log('data',data)
    this.ParamsHead = data;
    this.IsEdit = true;
    this.IsSearch = false;
    this.IsAdd = false;
    // this.hideCols.push("DELETE")
    
    this.GetDetail();
  }

  Back(){
    this.IsSearch = true;
    this.IsAdd = false;
    this.IsEdit = false;
  }


  GetHeader(){
    if(this.ParamsHead.REF_DOC_TYPE && this.ParamsHead.REF_DOC_NO){
      this.ConfigPartNo.SourceParams.DOCUMENT_TYPE = this.ParamsHead.REF_DOC_TYPE;
      this.ConfigPartNo.SourceParams.DOCUMENT_NO = this.ParamsHead.REF_DOC_NO;
      this.ConfigPartNo.SourceParams.DOCUMENT_TYPE_H = this.ParamsHead.DOCUMENT_TYPE;

      this.ConfigOrder.SourceParams.REF_DOC_TYPE = this.ParamsHead.REF_DOC_TYPE;
      this.ConfigOrder.SourceParams.REF_DOC_NO = this.ParamsHead.REF_DOC_NO;

      

      this.http.get("AC","SNSE041_M_GetHeader",this.ParamsHead.REF_DOC_TYPE,this.ParamsHead.REF_DOC_NO)
      .subscribe(res =>{
        console.log(res)
        this.ParamsHead.REF_DOC_TYPE = res.Table[0].REF_DOC_TYPE
        this.ParamsHead.REF_DOC_NO = res.Table[0].REF_DOC_NO
        this.ParamsHead.REF_DOC_DATE = res.Table[0].REF_DOC_DATE
        //this.ParamsHead.REF_INV_NO = res.Table[0].REF_INV_NO

        this.ParamsHead.REF_INV_NO = res.Table[0].REF_DOC_NO
        //this.ParamsHead.REF_ORDER_NO = res.Table[0].REF_ORDER_NO

        this.ParamsHead.CUSTOMER_CODE = res.Table[0].CUSTOMER_CODE
        this.ParamsHead.CUST_NAME_TH = res.Table[0].CUST_NAME_TH
        this.ParamsHead.CUST_ADDR1 = res.Table[0].CUST_ADDR1
        this.ParamsHead.CUST_ADDR2 = res.Table[0].CUST_ADDR2
        this.ParamsHead.DEST_PORT = res.Table[0].DEST_PORT ? res.Table[0].DEST_PORT : 'GL'
        this.ParamsHead.VAT_FLAG = res.Table[0].VAT_FLAG
        this.ParamsHead.VAT_RATE = res.Table[0].VAT_RATE
        this.ParamsHead.BRANCH_CODE = res.Table[0].BRANCH_CODE
        this.ParamsHead.BRANCH_NAME_TH = res.Table[0].BRANCH_NAME_TH
        this.ParamsHead.REASON_CODE = res.Table[0].REASON_CODE
        this.ParamsHead.TOTAL_OLD_AMT = res.Table[0].TOTAL_OLD_AMT
        this.ParamsHead.REASON_NAME_TH = res.Table[0].REASON_NAME_TH
        this.ParamsHead.DIF_QTY = 0.00
        this.ParamsHead.ATTRIBUTE5 = res.Table[0].ATTRIBUTE5 ? res.Table[0].ATTRIBUTE5 : '01'
        this.ParamsHead.RETURN_BAL = res.Table[0].TOTAL_QTY
        this.ParamsHead.LOCK_CUSTOMER = res.Table[0].LOCK_CUSTOMER
        this.ParamsHead.LOCK_BRANCH = res.Table[0].LOCK_BRANCH

        this.ConfigBranch.CUSTOMER_CODE = this.ParamsHead.CUSTOMER_CODE
        this.tableData = []
        //this.CreateDetailRow(0);

      })
    }
  }

  GetDetail(){
    this.tableData = [];
    this.http.post("AC","SNSE041_M_GetDetail",{DOC_NO : this.ParamsHead.DOCUMENT_NO,DOC_TYPE : this.ParamsHead.DOCUMENT_TYPE})
    .subscribe(res =>{
        this.tableData = res.Table
        this.ConfigPartNo.SourceParams.DOCUMENT_TYPE = this.ParamsHead.REF_DOC_TYPE
        this.ConfigPartNo.SourceParams.DOCUMENT_NO = this.ParamsHead.REF_DOC_NO
        this.ConfigPartNo.SourceParams.DOCUMENT_TYPE_H = this.ParamsHead.DOCUMENT_TYPE;
        if(!this.IsAdd){
          this.ParamsHead.REF_ORD_CLASS = this.tableData[0].ORDER_CLASS
        }
    })
  }

  GetNewDetail(){
    this.tableData = [];
    this.http.post("AC","SNSE041_M_GetNewDetail",{DOC_NO : this.ParamsHead.REF_DOC_NO,DOC_TYPE : this.ParamsHead.REF_DOC_TYPE})
    .subscribe(res =>{

      res.Table.map(x => {
        if(x.REF_DOC){
          x.NET_AMT_B = x.ITEM_QTY * x.UNIT_PRICE_B
        }
      })

        this.tableData = res.Table
        this.ConfigPartNo.SourceParams.DOCUMENT_TYPE = this.ParamsHead.REF_DOC_TYPE
        this.ConfigPartNo.SourceParams.DOCUMENT_NO = this.ParamsHead.REF_DOC_NO
        this.ConfigPartNo.SourceParams.DOCUMENT_TYPE_H = this.ParamsHead.DOCUMENT_TYPE;

       
        // if(!this.IsAdd){
        //   this.ParamsHead.REF_ORD_CLASS = this.tableData[0].ORDER_CLASS
        // }
    })
  }

  Save(){

    if(this.ParamsHead.LOCK_CUSTOMER !== 0 || this.ParamsHead.LOCK_BRANCH !== 0){
      this.modal.warning("Customer or Branch Locked",this.viewref,this.BeforeSave)
    }else{
      this.BeforeSave();
    }

  }

  BeforeSave = () => {
    if(this.tableData.filter(x => x.ORDER_PART_NO).length == 0){
      this.modal.warning("No detail data for save",this.viewref)
      return
    }


    if(!this.CheckValidateField()){
      this.modal.warning("Please input require field",this.viewref)
      return
    }

    this.modal.confirm("Do you want to save change you have made?",this.viewref,this.ConfirmSave)
  }

  ConfirmSave = () => {

        this.ParamsHead.Detail = this.tableData.filter(x => x.ORDER_PART_NO)
        this.http.post("AC","SNSE041_M_Insert",this.ParamsHead)
        .subscribe(res =>{
          console.log('rex',res)
          if(res.Table[0].STATUS == 'Done'){
            this.modal.info('Transaction complete: applied and saved.', this.viewref);
            this.ParamsHead.DOCUMENT_NO = res.Table[0].DOCUMENT_NO
            this.ParamsHead.DIF_QTY = res.Table[0].DIF_QTY
            this.Saved = true;
          }else{
            this.modal.error('No change to save. Something went wrong.', this.viewref);
          }
         
        })
  }

  SelectedCustomer(event){
    this.ParamsHead.CUSTOMER_CODE = event.CUSTOMER_CODE
    this.ParamsHead.CUST_NAME_TH = event.CUST_NAME_TH
    this.ParamsHead.CUST_ADDR1 = event.CUST_ADDR1
    this.ParamsHead.CUST_ADDR2 = event.CUST_ADDR2
    this.ParamsHead.LOCK_CUSTOMER = event.LOCK_CUSTOMER
    this.ConfigBranch.SourceParams.CUSTOMER_CODE = event.CUSTOMER_CODE
    
  }

  SelectedBranch(event){
    this.ParamsHead.BRANCH_CODE = event.BRANCH_CODE;
    this.ParamsHead.BRANCH_NAME_TH = event.BRANCH_NAME_TH
    this.ParamsHead.LOCK_BRANCH = event.LOCK_BRANCH
  }

  VatChange(event){
    if(event == null || event == "" || event == undefined){
      this.ParamsHead.DEST_PORT = 'AP'
    }
  }


  SetNewPartNo(part: any, data: any, index: number) {

    let findPartIndex = this.tableData.findIndex(v => v.ORDER_PART_NO == part.ORDER_PART_NO);

    if (part?.ORDER_PART_NO && findPartIndex >= 0 && findPartIndex !== index) {
      this.modal.warning("Duplicate part number.", this.viewref);
      data.ORDER_PART_NO = null;
      
      return;
    }


    // if(this.ParamsHead.DOCUMENT_TYPE == 'RO' || this.ParamsHead.DOCUMENT_TYPE == 'RN'){
    //   if(part.TOT_QTY == part.ITEM_QTY){
    //     this.modal.error("P# " + part.ORDER_PART_NO + " cannot be issued " + this.ParamsHead.DOCUMENT_TYPE + " quantity over " + this.ParamsHead.REF_DOC_TYPE + " quantity, Please recheck!",this.viewref)
    //     data.ORDER_PART_NO = null;
    //     return;
    //   }else{
    //     part.ITEM_QTY = part.ITEM_QTY - part.TOT_QTY
    //   }
    // }

    //if(this.ParamsHead.DOCUMENT_TYPE == 'RO' || this.ParamsHead.DOCUMENT_TYPE == 'RN'){
      if(part.TOT_QTY == part.ITEM_QTY){
        this.modal.error("P# " + part.ORDER_PART_NO + " cannot be issued " + this.ParamsHead.DOCUMENT_TYPE + " quantity over " + this.ParamsHead.REF_DOC_TYPE + " quantity, Please recheck!",this.viewref)
        data.ORDER_PART_NO = null;
        return;
      }else{
        part.ITEM_QTY = part.ITEM_QTY - part.TOT_QTY
      }
    //}

    //console.log('daaaaaaaaaaaa',data);
    //this.tempData.Part = part;
    data.ITEM_NO = part.ITEM_NO
    data.ORDER_PART_NO = part.ORDER_PART_NO;
    data.PART_NAME = part.PART_NAME;
    data.ORDER_NO = part.ORDER_NO;
    data.ITEM_QTY = part.ITEM_QTY;
    data.RETAIL_PRICE_B = part.RETAIL_PRICE_B;
    data.DISCOUNT_RATE1 = part.DISCOUNT_RATE1;
    data.DISCOUNT_RATE2 = part.DISCOUNT_RATE2;
    data.DISCOUNT_RATE3 = part.DISCOUNT_RATE3;
    data.UNIT_PRICE_B = part.UNIT_PRICE_B;
    data.NET_AMT_B = part.NET_AMT_B;
    data.ORDER_ITEM_NO = part.ORDER_ITEM_NO;
    data.SUB_ITEM_NO = part.SUB_ITEM_NO;

    //this.ParamsHead.RETURN_BAL += part.ITEM_QTY;
    this.ConfigOrder.SourceParams.ORDER_PART_NO = part.ORDER_PART_NO
    //this.tempTable = Object.assign({}, this.tableData);
  }

  QtyChange(oldvalue,data){

    if(!data.ITEM_QTY){
      data.ITEM_QTY = 0;
    }


    if(data.ITEM_QTY > oldvalue){
      this.modal.error("P# " + data.ORDER_PART_NO + " cannot be issued " + this.ParamsHead.DOCUMENT_TYPE + " quantity over " + this.ParamsHead.REF_DOC_TYPE + " quantity, Please recheck!",this.viewref)
      data.ITEM_QTY = oldvalue
    }else{

      data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B,2);
 
    }

    // if(this.ParamsHead.DOCUMENT_TYPE == 'RO' || this.ParamsHead.DOCUMENT_TYPE == 'RN'){
      
    //   if(data.ITEM_QTY > oldvalue){
    //     this.modal.error("P# " + data.ORDER_PART_NO + " cannot be issued " + this.ParamsHead.DOCUMENT_TYPE + " quantity over " + this.ParamsHead.REF_DOC_TYPE + " quantity, Please recheck!",this.viewref)
    //     data.ITEM_QTY = oldvalue
    //   }else{

    //     data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B,2);
   
    //   }
      
    // }else{
    //   data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B,2);
    // }



  }

  UnitPriceChange(oldvalue,event,data){

    if(!data.UNIT_PRICE_B){
      data.UNIT_PRICE_B = 0;
    }

    data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B,2)

    // if(parseInt(event) || parseFloat(event)){
    //   data.UNIT_PRICE_B =  event
    // }else{
    //   data.UNIT_PRICE_B = oldvalue
    // }

    //this.changeRef.markForCheck();
    //this.tableData = this.tableData.slice();
    //console.log('data.UNIT_PRICE_B',data.UNIT_PRICE_B)
    //data.UNIT_PRICE_B = event
    
  }

  OperList(index){
    this.ConfigOrder.SourceParams.ORDER_PART_NO = this.tableData[index].ORDER_PART_NO
    //console.log("testttttttttttttttt",index)
  }


  OrderChange(event,data,index){
    data.ORDER_NO = event.ORDER_NO;
    data.ITEM_QTY = event.ITEM_QTY;
    data.ORDER_ITEM_NO = event.ORDER_ITEM_NO;
    data.SUB_ITEM_NO = event.SUB_ITEM_NO;
  }

  DiscountChange(data,event,rate,oldvalue){
    console.log(data)



    if(event > 990.00){
      this.modal.error("Field must be of from 990.00",this.viewref)
      switch (rate) 
      {
        case 1 :
             data.DISCOUNT_RATE1 = oldvalue
          break;
        case 2 :
            data.DISCOUNT_RATE2 = oldvalue
          break;
        case 3 :
            data.DISCOUNT_RATE3 = oldvalue
          break;
        default:
          console.log("rate not macth")
      }
      return;
    }


    if(!event){
      switch (rate) 
      {
        case 1 :
             data.DISCOUNT_RATE1 = 0
          break;
        case 2 :
            data.DISCOUNT_RATE2 = 0
          break;
        case 3 :
            data.DISCOUNT_RATE3 = 0
          break;
        default:
          console.log("rate not macth")
      }
      
    }

    let NewUnitPrice = data.RETAIL_PRICE_B*((100 - (data.DISCOUNT_RATE1||0))/100)*((100 - (data.DISCOUNT_RATE2||0))/100)*((100- (data.DISCOUNT_RATE3||0)))/100
    data.UNIT_PRICE_B = this.global.Round(NewUnitPrice,2);

    data.NET_AMT_B = this.global.Round(data.ITEM_QTY * data.UNIT_PRICE_B,2)

  }

 

  CheckActiveRow(tblIndex) {
    // let valid: boolean = (this.ParamsHead.DOCUMENT_TYPE && this.ParamsHead.REF_DOC_TYPE && this.ParamsHead.REF_DOC_NO) ? true : false;

    // if (valid) {
    //   valid = (!this.tableData[tblIndex].INVOICE_PROCESS || this.tableData[tblIndex].INVOICE_PROCESS === 'N');
    // }

    // if (valid && tblIndex > 0) {
    //   let prevRow = this.tableData[tblIndex - 1];

    //   valid = (prevRow.ORDER_PART_NO && prevRow.ITEM_QTY) ? true : false;
    // }

    // if (valid && !this.IsEdit && !this.IsAdd) {
    //   this.CreateDetailRow(tblIndex);
    // }

    let valid : boolean = true;

    if(this.IsEdit || this.Saved){
      valid = false;
    }


    //valid = this.IsEdit ? false : true

    return valid;
  }


  CreateDetailRow(tblIndex) {
    let currentMaxRow: number = this.tableData.length || 0;
    let nextMaxRow: number = (Math.floor(currentMaxRow / 10) + 1) * 10;

    if (currentMaxRow - tblIndex <= 2) {
      for (let i = currentMaxRow; i < nextMaxRow; i++) {
        this.tableData.push({
          INVOICE_PROCESS: 'N'
        });
      }

      this.tableData = this.tableData.slice();
    }

    //console.log('ssssssss',this.tableData)

  }

  CheckValidateField(){
    let valid = false;
    if(this.ParamsHead.DOCUMENT_TYPE && 
      this.ParamsHead.REF_DOC_TYPE && 
      this.ParamsHead.REF_DOC_NO && 
      this.ParamsHead.REF_INV_NO && 
      this.ParamsHead.REASON_CODE != null){
      valid = true
    }

    return valid;
  }


  TotalQty() {
    return this.tableData.reduce((a, b) => a + (b.ITEM_QTY || 0), 0);
  }

  TotalAmount() {
    return this.tableData.reduce((a, b) => a + (b.NET_AMT_B || 0), 0);
  }

  TotalVat() {
    return this.global.Round((this.TotalAmount() * (this.ParamsHead.VAT_RATE || 0)) / 100,2)
  }

  TotalNetAmount(){
    return (this.TotalAmount() + this.TotalVat() || 0);
  }


  DeleteRow(index) {
    this.modal.confirm("Are you sure to remove this row?", this.viewref
      , () => {
        this.tableData.splice(index, 1);
        this.tableData = [...this.tableData];
       
      }, () => { })
  }

  
}
