import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'SNSE009',
  templateUrl: './SNSE009.component.html',
  styleUrls: ['./SNSE009.component.css']
})



export class SNSE009Component implements OnInit {

  public params: any = {}


  constructor(
    private http: HttpService,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  ngOnInit() {
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE010R_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public lookupOrderNoConfig: any = {
    ColName: "ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE010R_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCustomerCodeStart(values: any) {
    this.params.CUSTOMER_CODE_START = values.CUSTOMER_CODE;
  }

  public SetSelectedCustomerCodeEnd(values: any) {
    this.params.CUSTOMER_CODE_END = values.CUSTOMER_CODE;
  }

  public SetSelectedOrderNoStart(values: any) {
    this.params.ORDER_NO_START = values.ORDER_NO;
  }

  public SetSelectedOrderNoEnd(values: any) {
    this.params.ORDER_NO_END = values.ORDER_NO;
  }

  public GoToReport() {
    if (this.params.CUSTOMER_CODE_START && this.params.CUSTOMER_CODE_END && this.params.ORDER_NO_START && this.params.ORDER_NO_END) {
      this.global.GoToReport("PMS_RPT_SALES_SNSE009R", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_CUST_CODE_FROM: this.params.CUSTOMER_CODE_START,
        P_CUST_CODE_TO: this.params.CUSTOMER_CODE_END,
        P_ORDER_NO_FROM: this.params.ORDER_NO_START,
        P_ORDER_NO_TO: this.params.ORDER_NO_END
      })
    }
    else {
      this.modal.warning("Please fill Customer Code Or Order No.", this.viewref);
    }
  }
}
