import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
//import { Router } from '@angular/router';
//import { Globals } from 'src/app/core/global';
//import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';


@Component({
  selector: 'snse019',
  templateUrl: './SNSE019.component.html',
  styleUrls: ['./SNSE019.component.css']
})



export class SNSE019Component implements OnInit {

  constructor(
    private Http: HttpService,
    //private router: Router,
    //private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public params: any = {}
  public TableData1: any;
  public TableData2: any;
  public tblFooterData2: any = [
    {
      fieldName: "CUSTOMER_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "AMOUNT",
      value: null,
      show: true
    }
  ]
  public DataIsSelected: any;
  public selection = new SelectionModel<any>(true, []);
  public setIndex: any;

  ngOnInit() {
    this.params.PICK_LOT_DATE = new Date();
    this.params.PRINT_PICKING_CARD = 'Y';
    this.params.IsEdit = 'N'
    this.params.LOCATION = '0'
    this.getPickSeq();
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE019_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUST_NAME_EN;
  }

  public lookupOrderNoConfig: any = {
    ColName: "LOOKUP_ORDER_NO",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSE019_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedOrderNoStart(values: any) {
    this.params.SEQ_ORDER_NO_START = values.SEQ
    if (this.params.SEQ_ORDER_NO_END < this.params.SEQ_ORDER_NO_START) {
      this.modal.info("First values is not Larger then Last Value.", this.viewref)
      this.params.ORDER_NO_START = null;
      this.params.SEQ_ORDER_NO_START = 0;
    } else {
      this.params.ORDER_NO_START = values.ORDER_NO;
      this.params.ORDER_CLASS_START = values.ORDER_CLASS;
    }
  }

  public SetSelectedOrderNoEnd(values: any) {
    this.params.SEQ_ORDER_NO_END = values.SEQ
    if (this.params.SEQ_ORDER_NO_END < this.params.SEQ_ORDER_NO_START) {
      this.modal.info("First values is not Larger then Last Value.", this.viewref)
      this.params.ORDER_NO_END = null;
      this.params.SEQ_ORDER_NO_END = 0;
    } else {
      this.params.ORDER_NO_END = values.ORDER_NO;
      this.params.ORDER_CLASS_END = values.ORDER_CLASS;
    }
  }

  Search = () => {
    this.TableData1 = null;
    this.Http.post('SL', 'SNSE019_GetData', this.params)
      .subscribe(res => {
        this.TableData1 = res.Table;
        this.params.IsEdit = 'N'
        this.params.LOCATION = '0'
        this.TableData1.forEach(row => this.selection.select(row));
        this.DataIsSelected = [];
        this.TableData1.map(x => {
          this.DataIsSelected.push(x);
        })
        this.Http.post('SL', 'SNSE019_GetData2', this.params)
          .subscribe(res => {
            this.TableData2 = res.Table;
          })
      })
  }

  getPickSeq() {
    this.Http.get('SL', 'SNSE019_GetPickSeq')
      .subscribe(res => {
        this.params.PICK_LOT_SEQ = res.Table[0].PICK_LOT_SEQ;
      })
  }

  ConfirmProcess() {
    this.modal.confirm('Do you want to allowcate this order?', this.viewref, this.Process)
  }

  Process = () => {
    this.GoToReport();
    //  console.log(this.DataIsSelected)
    //  this.Http.post('SL', 'SNSE019_Process', this.DataIsSelected)
    //    .subscribe(res => {
    //      if (res.Table[0].STATUS == 'DONE') {
    //        
    //        this.Search();
    //        this.getPickSeq();
    //      }
    //      else {
    //        this.modal.warning(res.Table[0].MESSAGE, this.viewref);
    //      }
    //    })
  }

  CheckboxChange(event, data) {
    if (event.checked) {
      this.DataIsSelected.push(data);
    }
    else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
  }

  radioChange(type: any) {
    if (type == '0') {
      this.TableData1.forEach(row => this.selection.select(row));
      this.DataIsSelected = [];
      this.TableData1.map(x => {
        this.DataIsSelected.push(x);
      })
      this.params.IsEdit = 'N'
    }
    else {
      this.selection.clear()
      this.TableData1.map(x => {
        this.DataIsSelected = [];
      })
      this.params.IsEdit = 'Y'
    }
  }

  SelectedRec() {
    this.selection.clear();
    this.DataIsSelected = [];
    var indexFrom = this.params.LOCATION_FROM - 1
    var indexTo = this.params.LOCATION_TO - 1

    this.TableData1.forEach((e, index) => {
      if (index >= indexFrom && index <= indexTo) {
        this.selection.select(e)
        this.DataIsSelected.push(e);
      }
    });
  }

  GoToReport() {
    //this.global.GoToReport("PMS_RPT_IC_SNSD172_F", { P_YEAR: "2020", P_MONTH: "01" })
    this.modal.info("Waiting for report", this.viewref);
  }

}
