import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';

@Component({
    selector: 'snsr063f_a4',
    templateUrl: './SNSR063F_A4.component.html',
    styleUrls: ['./SNSR063F_A4.component.css']
})



export class SNSR063F_A4Component implements OnInit {


    constructor(
      private http: HttpService,
      private router: Router,
      private global: Globals,
      private modal: ModalService,
      private viewRef: ViewContainerRef
    ) { }

    public CustomerList: any = [];
    public params: any = {};

    ngOnInit() {
      var date = new Date();
      this.params.DATE_FROM = new Date(date.getFullYear(), date.getMonth(), 2);
      this.params.DATE_TO = new Date();
    }

    public ConfigDocStart: any = {
        ColName: "DOC_START",
        ColValue: "",
        PlaceholderText: "Select Document No Start",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetDocStart",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
    }

    public ConfigDocEnd: any = {
        ColName: "DOC_END",
        ColValue: "",
        PlaceholderText: "Select Document No End",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetDocEnd",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
    }

    public ConfigPartStart: any = {
        ColName: "PART_START",
        ColValue: "",
        PlaceholderText: "Select Part No Start",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetPartStart",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
    }

    public ConfigPartEnd: any = {
        ColName: "PART_END",
        ColValue: "",
        PlaceholderText: "Select Part No End",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetPartEnd",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
    }

    public ConfigCusStart: any = {
        ColName: "CUS_START",
        ColValue: "",
        PlaceholderText: "Select Customer Code Start",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetCusStart",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
    }

    public ConfigCusEnd: any = {
        ColName: "CUS_END",
        ColValue: "",
        PlaceholderText: "Select Customer Code End",
        SourceController: "SL",
        SourceMethodName: "SNSR063F_A4_GetCusEnd",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
  }


  public RunReport() {

    if (this.params.CUS_START && this.params.CUS_END && this.params.DATE_FROM && this.params.DATE_TO && this.params.DOC_START && this.params.DOC_END) {
      this.global.GoToReport("PMS_RPT_SALES_SNSR063R_A4", {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_S_CUSTOMER_CODE: this.params.CUS_START,
        P_E_CUSTOMER_CODE: this.params.CUS_END,
        P_S_DOCUMENT_DATE: moment(this.params.DATE_FROM).format('DD-MM-YYYY'),
        P_E_DOCUMENT_DATE: moment(this.params.DATE_TO).format('DD-MM-YYYY'),
        P_S_DOCUMENT_NO: this.params.DOC_START,
        P_E_DOCUMENT_NO: this.params.DOC_END
      })
    }
    else {
      this.modal.warning("Please fill Customer Code or Document No", this.viewRef);
    }
     
    }
}
