import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl } from '@angular/forms'
import { Router } from '@angular/router';
import { AuthService } from 'src/app/core/auth-service.service';

@Component({
  selector: 'login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.css']
})
export class LoginComponent implements OnInit {
  public errMsg: string = "";
  public loginForm: FormGroup = new FormGroup({
    username: new FormControl(''),
    password: new FormControl(''),
    company: new FormControl(''),
  })
  public showpwd: boolean = false;

  constructor(
    private http: HttpService,
    private router: Router,
    private authService: AuthService
  ) { }

  ngOnInit(): void {
    this.loginForm.get("company").setValue('01');
  }

  login() {
    this.errMsg = "";
    localStorage.clear();
    this.http.postLogin(this.loginForm.get("username").value, this.loginForm.get("password").value, this.loginForm.get("company").value)
      .subscribe(result => {
        this.authService.storeTokens(result);
        this.router.navigate(['/main'])
      }, (err) => {
        if (err.error && !(err.error instanceof Object)) {
          this.errMsg = err.error;
        } else {
          this.errMsg = err.message;
        }
      })
  }

  ChangePassword() {
    this.router.navigate(['/','changepwd']);
  }
}
