import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router } from '@angular/router';
import { Observable, config } from 'rxjs';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';

@Component({
  selector: 'snse026',
  templateUrl: './SNSE026.component.html',
  styleUrls: ['./SNSE026.component.css']
})



export class SNSE026Component implements OnInit {


  @ContentChild(TemplateRef, { static: false }) templateRef;
  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;

  constructor(
    private http: HttpService,
    private router: Router
  ) { }

  //@ViewChild('fileUpload') myInputVariable: ElementRef;

  @Input() config: any;
  @Input() data: any;
  @Output() datacallback = new EventEmitter<string>();


  public CustomerList: any;
  private loaded: boolean = false;

  public headerList: Array<any> = [];
  public headerListC: Array<any> = [];
  public dataList: any;
  public displayedColumns: string[] = [];
  public displayedColumnsC: string[] = [];
  public tableData: any;
  public isCustomContent: boolean = false;


  public tableDataC: any;
  public dataListC: any;

  public tableName: string;

  public Ischecked: boolean;


  ngOnInit() {

    this.tableName = "ReportConfigure";
    this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]



    this.headerList = [
      { FIELD_NAME: "Allocate_Date", TITLE: "Allocate Date" },
      { FIELD_NAME: "Check", TITLE: "" }
    ]

    console.log('headerList', this.headerList)

    this.tableData = [
      {
        "Allocate_Date": "A",
       
      }, {
        "Allocate_Date": "B",      
      },
      {
        "Allocate_Date": "C",
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",    
      },
      {
        "Allocate_Date": "A",  
      },
      {
        "Allocate_Date": "A",
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",    
      },
      {
        "Allocate_Date": "A",      
      },
      {
        "Allocate_Date": "A",        
      },
      {
        "Allocate_Date": "A",      
      }
    ]

    
    this.headerListC = [
      { FIELD_NAME: "Customer_Code", TITLE: "Customer Code" },
      { FIELD_NAME: "Customer_Name", TITLE: "Customer Name" },
      { FIELD_NAME: "Check", TITLE: "" }
    ]

    this.tableDataC = [
      { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "B", Customer_Name: "B" }, { "Customer_Code": "V", Customer_Name: "V" }, { "Customer_Code": "C", Customer_Name: "C" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" },
      { "Customer_Code": "A", Customer_Name: "A" }, { "Customer_Code": "A", Customer_Name: "A" }
    ]

    this.dataList = new MatTableDataSource<any>(this.tableData);
    this.dataListC = new MatTableDataSource<any>(this.tableDataC);

    this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);
    this.displayedColumnsC = this.headerListC.map(x => x.FIELD_NAME);
    
    this.loaded = true;
  }


  ngAfterContentInit(): void {
    if (this.templateRef) {
      this.isCustomContent = true;
    }
  }


  ngOnChanges(): void {

    this.dataList.paginator = this.paginator;
    this.dataList.sort = this.sort;
  }

  receiveMessage($event) {

  }








}
