import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { SelectionModel } from '@angular/cdk/collections';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'SNSE206',
    templateUrl: './SNSE206.component.html',
    styleUrls: ['./SNSE206.component.css']
})

export class SNSE206Component implements OnInit{

    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    public tableData = [];
    public formData: any = [];
    public APPROVE_STATUS: any = [];
    public selection = new SelectionModel<any>(true, []);
    public DataIsSelected: any = [];
    public params: any = {
      CHK_APPROVE: true,
      CHK_STATUS: 'N'
    };
    public data: any = {};
    
    ngOnInit() {
        
    }

    public ConfigDocCode: any = {
        ColName: "DOCUMENT_NO",
        PlaceholderText: "Select Document Code",
        SourceController: "SL",
        SourceMethodName: "SNSE206_GetDocNo",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: true
    }

    public ConfigCustCode: any = {
        ColName: "LOOKUP_CUST_CODE",
        PlaceholderText: "Select Customer Code",
        SourceController: "SL",
        SourceMethodName: "SNSE206_GetCustCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: true
    }

    public ConfigReasonCode: any = {
        ColName: "LOOKUP_REASON_CODE",
        PlaceholderText: "Select Reason Code",
        SourceController: "SL",
        SourceMethodName: "SNSE206_Reason_Code",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: true
    }

    public SetDocCode(value: any) {
      this.params.DOCUMENT_NO = value.DOCUMENT_NO;
    }

    public SetCustCode(value: any) {
      this.params.CUSTOMER_CODE = value.CUSTOMER_CODE;
    }

    public SetReasonCode(value: any, data: any) {
      data.REASON_CODE = value.REASON_CODE;
    }

    public CheckApprove(event) {
      this.params.CHK_APPROVE == true ? this.params.CHK_STATUS = 'N' : this.params.CHK_STATUS = null;
    }

    public Search() {
      //console.log(this.params)
      this.tableData = [];
      this.http.post("SL", "SNSE206_GET_DATA", this.params)
        .subscribe(res => {
          this.tableData = res.Table;
          //this.totalRecord = this.tableData.length
        })
    }

    public isAllSelected() {
      const numSelected = this.selection.selected.length;
      const numRows = this.tableData.length;
      return numSelected === numRows;
    }

    public Toggle() {
      if (this.isAllSelected()) {
        this.selection.clear()
        this.tableData.map(x => {
          this.DataIsSelected = [];
        })
      } else {
        this.tableData.forEach(row => this.selection.select(row));
        this.DataIsSelected = [];
        this.tableData.map(x => {
          this.DataIsSelected.push(x);
        })
      }
    }

    public CheckboxChange(event, data) {
      if (event.checked) {
        this.DataIsSelected.push(data);
      }
      else {
        this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
      }
    }

    public RadioChangeAll(event: any) {
      this.formData = [];
      this.tableData.forEach((e) => {
        e.APPROVE_STATUS = event;
        this.formData.push(e);
      });
      //console.log(this.formData,"All");
    }

    public RadioChangeRow(event: any) {
      this.formData = [];
      this.tableData.forEach((row) => {
        this.formData.push(row);
      })
      //console.log(this.formData,"Row");
    }

    public Confirm() {
      console.log(this.formData);
      this.modal.confirm("Do you want to save your change?", this.viewref,
        () => {
          this.http.post('SL', 'SNSE206_UPDATE', this.formData)
            .subscribe(res => {
              if (this.formData.length == 0) {
                this.modal.error("Please select some data", this.viewref)
              }
              if (res.Table[0].STATUS === "Done") {
                this.modal.info('Save successfully : ' + this.formData.length + ' data', this.viewref)
                this.formData = [];
                this.Search();
              }
            }, (err) => {
              console.log(err, 'err')
            })
        }, () => { })
      }



  





}
