import { Component, OnInit, ViewContainerRef, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { FormGroup, FormControl, FormBuilder } from '@angular/forms'
import { Router, ActivatedRoute } from '@angular/router';
import { SelectionModel } from '@angular/cdk/collections';
import { MatDatepickerInputEvent } from '@angular/material/datepicker';
import { MatTableDataSource } from '@angular/material/table';
import { ModalService } from '../../../core/modal.service';
import { MatPaginator } from '@angular/material/paginator';
import { Globals } from 'src/app/core/global';
//import * as moment from 'moment';
//
//

@Component({
  selector: 'snsq040',
  templateUrl: './SNSQ040.component.html',
  styleUrls: ['./SNSQ040.component.css']
})



export class SNSQ040Component implements OnInit {

  constructor(
    private http: HttpService,
      private router: Router,
      private modal: ModalService,
      private viewref: ViewContainerRef,
      private global : Globals,
      private route: ActivatedRoute
  ) { 

}

  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;

  @ViewChild("dialog", { static: false }) dialog: any;
  @ViewChild("dialogLog", { static: false }) dialogLog: any;


    DefualtDateFrom = new FormControl();
    DefualtDateTo = new FormControl();
    public VendorTypeList: any = [];
    public IndentStatusList: any = [];
    public RecommandIDList: any = [];
    public FPoNoList: any = [];
    public VendorCodeList: any = [];

    public tableData: any;
    public tableData2: any = [];
    public headerList: any = [];
    public headerList2: any = [];
    public dataList: any = [];
    public dataList2: any = [];
    public displayedColumns: string[] = [];
    public displayedColumns2: string[] = [];

    public selection = new SelectionModel<any>(true, []);
    public countTab1: number = 0;
    public countTab2: number = 0;
    public countTab3: number = 0;

    public tableName: string;
    public show: boolean = true;
    public SelectList: any = [];
    public tableData3: any = [];

    public qIscheckall: boolean = true;
    public IndentStatus: string = "A";
    public clickedRow: any;

    public displayedColumnsPO: string[] = ['FPO_No', 'FPO_Date','Recommand_ID','Project_ID','Vendor_Code'];
    public selection2 = new SelectionModel<any>(false, null);
    public ListLog : any = [];
    public showNoRecord: boolean = true;
    public Param: any = {

        DATE_FROM: null,
        DATE_TO: null,
        VENDOR_CODE: null,
        FPO_NO: null,
        RECOMMAND_ID: null,
        VENDOR_TYPE: 'A',
        INDENT_STATUS : 'A'


    };

    public ConfigVendor: any = {
        ColName: "LOOKUP_VENDOR_NAME",
        ColValue: "VENDOR_CODE",
        PlaceholderText: "Select vendor",
        SourceController: "wPMS",
        SourceMethodName: "GetVendorCode",
        NoOfShowRecords: 30,
        MinLengthSearch: 1
      }

    public ConfigFPO: any = {
        ColName: "NAME",
        ColValue: "FPO_NO",
        PlaceholderText: "FPO NO",
        MinLengthSearch: 0
    }

    ngOnInit() {

        var date = new Date();
        var firstDay = new Date(date.getFullYear(), date.getMonth(), 1);
        firstDay.setDate(firstDay.getDate() + 1);
        var toDay = new Date(date.getFullYear(), date.getMonth(), date.getDate());
        toDay.setDate(toDay.getDate() + 1);

        this.DefualtDateFrom = new FormControl(firstDay)
        this.DefualtDateTo = new FormControl(toDay)

        this.Param.DATE_FROM =  this.SetFormateDate(firstDay);
        this.Param.DATE_TO = this.SetFormateDate(toDay);


        this.VendorTypeList = [
            { ID: 'A', NAME: 'ALL' },
            { ID: 'J', NAME: 'J : Japan' },
            { ID: 'K', NAME: 'K : Import (Not Japan)' },
            { ID: 'L', NAME: 'L : Local' },
            { ID: 'O', NAME: 'O : Oil' }]

        this.IndentStatusList = [
            { ID: 'A', NAME: 'ALL' },
            { ID: 'N', NAME: 'Wait' },
            { ID: 'Y', NAME: 'For Web' },
            { ID: 'O', NAME: 'Firm ETD Date Over' },
            { ID: 'E', NAME: 'FPO Expire' }]

        this.GetHeaderTab1();
        this.GetHeaderTab2();
        //this.GetVendor();


        
    }

    getTableHeader(tableName: string) {

        return this.http.get("System", "GetHeaderGridView", tableName).toPromise()

    }

    async GetHeaderTab1() {
      
        this.headerList = await this.getTableHeader('SNSQ040_Tab1');
        this.headerList = this.headerList.filter(v => v.VISIBILITY === true);
        this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);
       

    }

    async GetHeaderTab2() {
        this.headerList2 = await this.getTableHeader('SNSQ040_Tab2');
        this.headerList2 = this.headerList2.filter(v => v.VISIBILITY === true);
        this.displayedColumns2 = this.headerList2.map(v => v.FIELD_NAME);
    }

    GetCriteria() {
        this.http.post('IC', 'SNSQ040_GetCriteria', JSON.stringify(this.Param))
            .subscribe(res => {
                this.VendorCodeList = res.Table;
                //this.FPoNoList = res.Table1;
              this.RecommandIDList = res.Table2;

              if(res.Table1.length > 0){
                  this.showNoRecord = false;
              }else{
                  this.showNoRecord = true;
              }

              this.FPoNoList = new MatTableDataSource(res.Table1);
            })
    }



    Search() {
        this.tableData2 = [];
        this.tableData3 = [];
        this.selection.clear();
        this.http.post('IC', 'SNSQ040_GetIndentFPO', JSON.stringify(this.Param))
            .subscribe(res => {
                this.tableData = res.Table
                this.IndentStatus = res.Table1[0].INDENT_STATUS;
                this.qIscheckall = this.tableData.some(x => x.SEND_STATUS == 'Y');
                this.dataList.paginator = this.paginator;
                if (this.IndentStatus != 'N') {
                    this.SetSelection();
                }

                this.countTab1 = this.tableData.length;
                this.ListLog.push("Loading TPM_INDENT_FPO_HEADER... " + res.Table.length +" records loaded...")
                this.GetCriteria();
            })
    }

    GetDataTab2(FPO_NO) {
      this.tableData2 = [];
        this.http.get('IC', 'SNSQ040_GetIndentDetailTab2', FPO_NO)
            .subscribe(res => {
                this.tableData2 = res.Table
                //this.dataList2 = new MatTableDataSource<any>(this.tableData2);
              this.countTab2 = this.tableData2.length;
              //this.dialog.OpenDialog();
            })
    }

    GetDataTab3(ITEM_NO,FPO_NO) {
        this.tableData3 = [];
        this.http.get('IC', 'SNSQ040_GetIndentStatusTab3',ITEM_NO, FPO_NO)
            .subscribe(res => {
               
                this.tableData3 = res.Table
                this.countTab3 = this.tableData3.length;
            })
    }


    Save() {
        this.modal.confirm('Do you want to Confirm Update ?', this.viewref, this.Commit);
    }

    Commit = () => {

        this.http.post('IC', 'SNSQ040_UpdateIndentHeader',JSON.stringify(this.selection.selected))
            .subscribe(res => {
                if (res.Table[0].STATUS == 'Done') {
                    this.modal.info('Process Complete.', this.viewref);
                    this.Search();
                } else {
                    this.modal.error(res.Table[0].MESSAGE, this.viewref);
                }
                  
            })
    }


    DateChange(event : MatDatepickerInputEvent<Date>, type: string) {
        //console.log('event', event);
        if (type == 'From') {
            this.Param.DATE_FROM = this.SetFormateDate(event.value);
        } else {
            this.Param.DATE_TO = this.SetFormateDate(event.value);
      }

      this.GetCriteria();
  }


    SetSelectedVendorCode(event) {
        this.Param.VENDOR_CODE = event
    }

    SetSelectedFPO(event) {
        this.Param.FPO_NO = event
    }


    isAllSelected() {
        const numSelected = this.selection.selected.length;
        const numRows = this.tableData.length;
        return numSelected === numRows;
    }

    Toggle() {
        this.isAllSelected() ?
            this.selection.clear() :
            this.tableData.forEach(row => this.selection.select(row));
    }

    SetSelection() {
        this.tableData.forEach(row => row.SEND_STATUS == 'Y' ? this.selection.select(row) : null)
    }

    ClickRow(event){
        this.tableData3 = [];
        this.GetDataTab2(event.FPO_NO)
    }

    // ClickRow(row, event) {
    //     if (event.target.className != "ng-star-inserted") {
    //         return
    //     } else {
    //       this.clickedRow = row;
    //       this.tableData3 = [];
    //         this.GetDataTab2(row.FPO_NO)
    //     }
    // }

    ClickRow2(row) {
        console.log('row', row)
        this.GetDataTab3(row.ITEM_NO,row.FPO_NO)
    }

    Export() {


        this.http.Download('IC', 'SNSQ040_Download', JSON.stringify(this.tableData))
            .subscribe(res => {
                if (res) {
                  this.writeContents(res)
                  this.ListLog.push("Export to CSV file : This PC:/Downloads : " + this.tableData.length + " records...")
                } else {
                    this.modal.error('Download Not Complete', this.viewref)
                    this.ListLog.push("Export to CSV file : Not Complete")

                }

            })

    }

  writeContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ040_FILE" + '' + this.global.CurrentDate() + '' + ".csv";
    a.click();
  }

    SetFormateDate(date) {

        let d = new Date(date);
          
        let day = d.getDate();
        let newDay = day.toString().length < 2 ? 0 + '' + day : day
        let year = d.getFullYear()
        let month = d.getMonth() + 1;
        let newMonth = month.toString().length < 2 ? 0 + '' + month : month

        return newDay + '-' + newMonth + '-' + year;

  }

  applyFilter(filterValue: string) {
    this.FPoNoList.filter = filterValue.trim().toLowerCase();
  }

  OK() {
    this.dialog.Close();
    console.log('selection', this.selection2.selected)
    let data = this.selection2.selected[0];

    this.Param.FPO_NO = data.FPO_NO
   
  }

  Cancel() {
    this.dialog.Close();

  }

  compareRow(row1: any, row2: any) {
    return JSON.stringify(row1) === JSON.stringify(row2);
  }

 

}
