import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { FormControl, Validators } from '@angular/forms';

@Component({
    selector: 'snm010p',
    templateUrl: './snm010p.component.html',
    styleUrls: ['./snm010p.component.css']
})



export class SNM010PComponent implements OnInit {



    constructor(
        private http: HttpService,
        private router: Router,
        private modal : ModalService,
        private viewref : ViewContainerRef
      ) { }
      @ViewChild("dialog",{static: false}) dialog : any;
      public ParamSearch :any ={};
      public Params :any ={};
      public categoryList: any = [];
      public tabledata : any = [];
      public isAdd : boolean = false;
    
      public ConfigPricingCode: any = {
        ColName: "PRICING_CODE",
        ColValue: "PRICING_CODE",
        PlaceholderText: "Select Pricing Code",
        SourceController: "TI",
        SourceMethodName: "SNM010P_GetPricingCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 0,
        UpperCase: false
      }
    
    
      ngOnInit() {
       
        
      }
    
      Search(){
        this.tabledata = []
        this.http.post("TI","SNM010P_GetPricingDetail",this.ParamSearch)
        .subscribe(res =>{
              this.tabledata = res.Table
        })
    
      }
    
      Add(){
        this.Params = {}
        this.Params.MARK_UP = 0
        this.Params.ATTRIBUTE1 = 1
        this.Params.PRINT_PRICE = 'Y'
        this.Params.CALCULATE_PRICE = 'Y'
        this.isAdd = true
        this.dialog.title = "Add Pricing Code"
        this.dialog.OpenDialog();
      }
    
      EditRow(data){
        this.isAdd = false;
        this.Params = data;
        this.dialog.title = "Edit Pricing Code"
        this.dialog.OpenDialog();
      }
    
      Delete(data){
         
        this.modal.confirm("Do you want to delete racord?",this.viewref,() =>{
          this.http.get("TI","SNM010P_Delete",data.PRICING_CODE)
          .subscribe(res =>{
            if (res.Table[0].STATUS == 'Done') {
              this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
              this.Search();
              this.dialog.Close();
                
            } else {
                this.modal.warning('Delete fail.', this.viewref);
            }
          },(err) => {
            this.modal.warning('Delete fail.', this.viewref);
          })
        })
      }
    
    
      Save(){
        this.modal.confirm("Do you want to save change you have made?",this.viewref,this.ConfirmSave)
      }
    
      ConfirmSave = () =>{
    
        if(this.isAdd){
          this.http.post("TI","SNM010P_Insert",this.Params)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'Done') {
              this.modal.info('Transaction complete: applied and saved.', this.viewref);
              if(this.tabledata.length > 0){
                this.Search();
              }
              this.dialog.Close();                                 
            } else if (res.Table[0].STATUS == 'Duplicate') {
                this.modal.info('No change to save. Found duplicate record.', this.viewref);
            }
            else {
                this.modal.warning('No change to save. Add fail.', this.viewref);
            }
          })
        }else{
          this.http.post("TI","SNM010P_Update",this.Params)
          .subscribe(res => {
            if (res.Table[0].STATUS == 'Done') {
              this.modal.info('Transaction complete: applied and saved.', this.viewref);
              this.Search();
              this.dialog.Close();
                
            } else {
                this.modal.warning('No change to save. Update fail.', this.viewref);
            }
          })
        }
    
      }
      Cancel(){
        this.dialog.Close();
      }
    
}

