import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snm038p',
  templateUrl: './SNM038P.component.html',
  styleUrls: ['./SNM038P.component.css']
})



export class SNM038PComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal : ModalService,
    private viewref : ViewContainerRef
  ) { }
  @ViewChild("dialog",{static: false}) dialog : any;
  public ParamSearch :any ={};
  public Params :any ={};
  public categoryList: any = [];
  public tabledata : any = [];
  public isAdd : boolean = false;
  public CategoryControl = new FormControl('',[Validators.required])

  public ConfigJobtype: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Main Model",
    SourceController: "TI",
    SourceMethodName: "SNM038P_GetMainModel",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: false
  }



  ngOnInit() {

  }

  Search(){
    this.tabledata = []
    this.http.post("TI","SNM038P_GetMainModelList",this.ParamSearch)
    .subscribe(res =>{
      //console.log(res)
          this.tabledata = res.Table
    })

  }

  Add(){
    this.Params = {}
    this.Params.CAR_MARKET_TYPE = 'C';
    this.Params.CAR_PROD_TYPE = 'O';
    this.Params.ITEM_NO = 0
    this.isAdd = true
    this.dialog.title = "Add Main Model"
    this.dialog.OpenDialog();
  }

  EditRow(data){
    this.isAdd = false;
    this.Params = data;
    this.dialog.title = "Edit Main Model"
    this.dialog.OpenDialog();
  }

  Delete(data){
    this.modal.confirm("Do you want to delete racord?",this.viewref,() =>{
      this.http.get("TI","SNM038P_DELETE",data.MAIN_MODEL)
      .subscribe(res =>{
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
          this.Search();
          this.dialog.Close();
            
        } else {
            this.modal.warning('Delete fail.', this.viewref);
        }
      })
    })
  }


  Save(){
    this.modal.confirm("Do you want to save change you have made?",this.viewref,this.ConfirmSave)
  }

  ConfirmSave = () =>{

    if(this.isAdd){
      this.http.post("TI","SNM038P_Insert",this.Params)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          if(this.tabledata.length > 0){
            this.Search();
          }
          this.dialog.Close();                                 
        } else if (res.Table[0].STATUS == 'Duplicate') {
            this.modal.info('No change to save. Found duplicate record.', this.viewref);
        }
        else {
            this.modal.warning('No change to save. Add fail.', this.viewref);
        }
      },(err)=>{
        this.modal.warning('No change to save. Add fail.', this.viewref);
      })
    }else{
      this.http.post("TI","SNM038P_UPDATE",this.Params)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.Search();
          this.dialog.Close();
            
        } else {
            this.modal.warning('No change to save. Update fail.', this.viewref);
        }
      })
    }

  }
  Cancel(){
    this.dialog.Close();
  }
  
  

}
