import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from '../../../core/modal.service';
import { FormControl, Validators } from '@angular/forms';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { HttpClient } from '@angular/common/http';
import { Globals } from '../../../core/global';

@Component({
  selector: 'SNSD162',
  templateUrl: './SNSD162.component.html',
  styleUrls: ['./SNSD162.component.css']
})



export class SNSD162Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private auth: AuthDecode,
    private httpC: HttpClient,
    private global: Globals
  ) { }
  @ViewChild("dialog", { static: false }) dialog: any;

  public tableData: any = [];

  public Config: any = {
    ColName: "PART_NO",
    ColValue: "PART_NO",
    PlaceholderText: "Select Part",
    SourceController: "WH",
    SourceMethodName: "SNSD162_GetPartNo",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }
  public FindCon = "";
  public params = {
    PART_FROM: null,
    PART_TO: null
  }
  GeFrmS(code) {
    this.params.PART_FROM = code;
  }
  GetToS(code) {
    this.params.PART_TO = code;
  }
  public TableData: any = [];
  ngOnInit() {

  }

 
  btnSelect(p) {
    if (this.FindCon === "F") {
      this.params.PART_FROM = p.PART_NO;
      this.dialog.Close();
    }
    else if (this.FindCon === "T") {
      this.params.PART_TO = p.PART_NO;
      this.dialog.Close();
    }
  }

  OpenRpt() {
    this.global.GoToReport("PMS_RPT_WH_SNSD162",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_PART_FROM: this.params.PART_FROM,
        P_PART_TO: this.params.PART_TO
      }
    );
  }

  OpenStart(p) {
    this.FindCon = p;
    this.tableData = [];
    this.http.get("WH", "SNSD162_GetPartNo")
      .subscribe(result => {
        this.tableData = result.Table;
        this.dialog.OpenDialog();
      });
  }
}
