
import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({
  selector: 'snse054d_z',
  templateUrl: './SNSE054D_Z.component.html',
  styleUrls: ['./SNSE054D_Z.component.css']
})



export class SNSE054D_ZComponent implements OnInit {


  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) { }
  
  
  public dataListSeqByInvoiceDate: any =[];
  public dataListCustByInvoiceDateBySeq: any =[];

  public PROCESSTYPE: any = {
      E21: "E21",
      E5:  "E5",
      R5:  "R5",
      I3:  "I3"
  };

  public METHOD_E21: string ="SNSE054D_Z_PitkLotDate_Find_E21";
  public METHOD_E5: string ="SNSE054D_Z_PitkLotDate_Find_E5";
  public METHOD_R5: string ="SNSE054D_Z_PitkLotDate_Find_R5";
  public METHOD_I3: string ="SNSE054D_Z_PitkLotDate_Find_I3";

  public selectedProcessType: string;

  public ListDataReportCondition: any = {
      PROCESS_TYPE : null, 
      PICK_LOT_DATE : null,
      PICK_LOT_SEQ : null,
      CUSTOMER_CODE : null
  };

  // public ConfigPickLotDate: any = {
  //   ColName: "PICK_LOT_DATE",
  //   ColValue: "PICK_LOT_DATE",
  //   PlaceholderText: "Select Pick Lot Date in format[DD-MM-YYYY]",
  //   SourceController: "WH",
  //   SourceMethodName: "SNSE054D_Z_PitkLotDate_Find_E21",
  //   NoOfShowRecords: 100,
  //   MinLengthSearch: 1,
  // }
  public ConfigPickLotDate: any = {
      ColName: "PICK_LOT_DATE",
      ColValue: "PICK_LOT_DATE",
      PlaceholderText: "Select Pick Lot Date in format[DD-MM-YYYY]",
      SourceController: "WH",
      SourceMethodName: "SNSE054D_Z_PitkLotDate_Find_E21",
      NoOfShowRecords: 100,
      MinLengthSearch: 1,
      UpperCase: true
  }

  ngOnInit() {
      this.ListDataReportCondition.PROCESS_TYPE = this.PROCESSTYPE.E21;

      this.ConfigPickLotDate.SourceMethodName = this.METHOD_E21;//Load Pick lot Date to autocomplete
      //this.ConfigPickLotDate.SourceMethodName = this.METHOD_E5;
      //this.ConfigPickLotDate.SourceMethodName = this.METHOD_E21;
      //this.ConfigPickLotDate.SourceMethodName = this.METHOD_E21;
  }

  FindSeqByInvoiceDate(strDate: any){
      // console.log(strDate);
      if (!!strDate) {
        // console.log("Before data: ",this.dataListSeqByInvoiceDate);
        this.HttpService.get("WH", "SNSE054D_Z_SEQ_BY_DATE" ,strDate || "null",this.PROCESSTYPE.E21)
        .subscribe(result => {

            //clear data that reletion with date.
            this.ListDataReportCondition.PICK_LOT_SEQ = null;
            this.ListDataReportCondition.CUSTOMER_CODE = null;

            this.dataListSeqByInvoiceDate = result.Table;
            //console.log("After Seq: ",this.dataListSeqByInvoiceDate);
        }, err => {
            this.modal.error(err.message, this.viewref);
        });

      } else {
        alert('Please input at less 3 characters');
      }
  }

  SeqSelectChange(iSeq: any){
      // console.log(iSeq);
      // console.log(typeof iSeq);
      this.FindCustByDateSeq(this.ListDataReportCondition.PICK_LOT_DATE,iSeq);
  }

  FindCustByDateSeq(strDate: any,strSeq: any){
      // console.log("Input func: "+strDate+"and"+strSeq);
      if (!!strDate) {
        // console.log("Before Cust: ",this.dataListCustByInvoiceDateBySeq);
        this.HttpService.get("WH", "SNSE054D_Z_CUST_BY_DATE_SEQ" ,strDate || "null",this.PROCESSTYPE.E21,strSeq)
        .subscribe(result => {

            //clear data that reletion with date.
            this.ListDataReportCondition.CUSTOMER_CODE = null;

            this.dataListCustByInvoiceDateBySeq = result.Table;
            // console.log("After Cust: ",this.dataListCustByInvoiceDateBySeq);
        }, err => {
            this.modal.error(err.message, this.viewref);
        });
      } else {
        alert('Please input at less 3 characters');
      }
  }

  // public ConfigPickLotSeq: any = {
  //   ColName: "PICK_LOT_SEQ",
  //   ColValue: "PICK_LOT_SEQ",
  //   PlaceholderText: "Select Seq",
  //   SourceController: "WH",
  //   SourceMethodName: "SP_NP_SNSD054D_Z_GET_SEQ",
  //   NoOfShowRecords: 100,
  //   MinLengthSearch: 1,
  // }

  // public ConfigCustCode: any = {
  //   ColName: "CUST_NAME_TH",
  //   ColValue: "CUSTOMER_CODE",
  //   PlaceholderText: "Select Customer Code",
  //   SourceController: "WH",
  //   SourceMethodName: "SP_NP_SNSD054D_Z_GET_CUST",
  //   NoOfShowRecords: 100,
  //   MinLengthSearch: 1,
  // }  

  radioChange(value: any){
      console.log(this.ListDataReportCondition.PROCESS_TYPE);
      this.clearData();

      //reload autocomplete follow radio change.
      if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.E21 ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_E21;
      }else if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.E5 ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_E5;
      }
      else if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.R5 ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_R5;
      }else if(this.ListDataReportCondition.PROCESS_TYPE == this.PROCESSTYPE.I3 ){
          this.ConfigPickLotDate.SourceMethodName = this.METHOD_I3;
      }
  }

  clearData(){
      //this.ListDataReportCondition.PROCESS_TYPE = null;
      this.ListDataReportCondition.PICK_LOT_DATE = null;
      this.ListDataReportCondition.PICK_LOT_SEQ = null;
      this.ListDataReportCondition.CUSTOMER_CODE = null;
  }

  OpenReport(){
      if(this.CheckSearchCondition()){
        console.log("Sent to Report:",this.ListDataReportCondition);
        //alert('Wait confirm kop in condition.');
        this.SavePackingCardBeforePrint(this.ListDataReportCondition.PICK_LOT_DATE,this.ListDataReportCondition.PROCESS_TYPE,this.ListDataReportCondition.PICK_LOT_SEQ,this.ListDataReportCondition.CUSTOMER_CODE );
        //this.GoToReport();//show roport viewer.
      }  
  }

  CheckSearchCondition():boolean{
      let boolHadSelectedCondition : boolean;
      boolHadSelectedCondition = false;//maening: User is not selecting condition search report.
      
      if(!this.ListDataReportCondition.PICK_LOT_DATE || !this.ListDataReportCondition.PICK_LOT_SEQ || !this.ListDataReportCondition.PROCESS_TYPE ){
          boolHadSelectedCondition = false;
      }else{
          boolHadSelectedCondition = true;
      }

      //Check Customer_Code if string emply or NULL will set to "null"
      if( !this.ListDataReportCondition.CUSTOMER_CODE ){
        this.ListDataReportCondition.CUSTOMER_CODE = "null";
      }

      return boolHadSelectedCondition;
  }//end CheckSearchCondition

  GoToReport() {
    this.global.GoToReport("PMS_RPT_WH_SNSE054R_ZB", {  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode") 
                                                  });
  }

  SavePackingCardBeforePrint(strDate:string ,strProcessType:string ,strSeq:string,strCustomerCode:any){
    //if (!!this.ListDataReportCondition.PICK_LOT_SEQ) {
        console.log("Data save sticker:", this.ListDataReportCondition);
        this.HttpService.get("WH", "SNSE054D_Z_SAVE_TO_TEMP" ,strDate,strProcessType,strSeq,strCustomerCode || "null")
        .subscribe(result => {
          console.log("result of save sticker: ",result);
          
          this.GoToReport();//show roport viewer.

        }, err => {
            this.modal.error(err.message, this.viewref);
        });
    //}
  }

}




