
import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';


@Component({
    selector: 'snsr041',
    templateUrl: './SNSR041.component.html',
    styleUrls: ['./SNSR041.component.css']
})



export class SNSR041Component implements OnInit {


    constructor(
        private HttpService: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private router: Router,
        private global: Globals

    ) { }
    
    public ListDataReportCondition: any = {
        CUSTOMER_CODE : null,//Step 1
        CUSTOMER_BRANCH : null,
        BRANCH_CODE : null,
        BRANCH_NAME : null,
        CASHEER_NO : null,//Step 2
        C_TOTAL_PAGE: null,//Step 3

        CUSTOMER_NAME : null,
        CUSTOMER_AMPHUR : null,
        DOCUMENT_NO : null,//Step 4
        CUSTOMER_PROVINCE: null
    };

    public dataListDialogInvoiceDate: any = [];
    public findingWord: string;

    public dataListDocNo: any = [];

    public ConfigCustomer: any = {
        ColName: "LOOKUP_CUSTOMER",
        ColValue: "CUSTOMER_BRANCH",
        PlaceholderText: "Select Customer Code",
        SourceController: "WH",
        SourceMethodName: "SNSR041_FindCustomer",
        NoOfShowRecords: 100,
        MinLengthSearch: 1,
        UpperCase: true
    }

    public CustomerList: any = [];

    ngOnInit() {
        this.ListDataReportCondition.CASHEER_NO = 'C.1';
        this.ListDataReportCondition.C_TOTAL_PAGE = 1;

        console.log("Show IPAddress:", this.global.GetTokenDetail("ssIPAddress"));
    }

    // FindCustInfo(){
    //     // console.log("Show Customer Code: ",this.ListDataReportCondition.CUSTOMER_BRANCH);
    //     this.fillCustInfo(this.ListDataReportCondition.CUSTOMER_BRANCH);
    // }

    public fillCustInfo(strCustomerBranch:any){
        console.log("Show Customer Code: ",strCustomerBranch);
        if (!!strCustomerBranch) {
          this.HttpService.get("WH", "SNSR041_Customer_Info", strCustomerBranch || "null")
          .subscribe(result => {
  
            console.log("After data: ",result);
            
            if(result.Table.length > 0 ){
              this.ListDataReportCondition.CUSTOMER_CODE = result.Table[0].CUSTOMER_CODE;
              this.ListDataReportCondition.CUSTOMER_NAME = result.Table[0].CUSTOMER_NAME;
              //this.ListDataReportCondition.CUSTOMER_AMPHUR = result.Table[0].AMPHUR;
              this.ListDataReportCondition.CUSTOMER_PROVINCE = result.Table[0].PROVINCE;

              this.ListDataReportCondition.BRANCH_CODE = result.Table[0].BRANCH_CODE;
              this.ListDataReportCondition.BRANCH_NAME = result.Table[0].BRANCH_NAME;
              //console.log("ListData CustInfo: ",this.ListDataReportCondition);

              this.fillListDocNo(strCustomerBranch);
            }
  
          }, err => {
              this.modal.error(err.message, this.viewref);
          });
  
        } else {
          alert('Please input customer code and branch code');
        }
    }

    public fillListDocNo(strCustomerBranch:any){
        //Un fill now wait confim.
        // if (!!strCustomerBranch) {
        //     //console.log("Data strCustBrach", strCustomerBranch);
        //     this.HttpService.get("WH", "SNSR040_DocumentByCustomer", strCustomerBranch || "null")
        //     .subscribe(result => {
        //       //console.log("list data DocNo: ",result);
        //       if(result.Table.length > 0 ){
        //         this.dataListDocNo = result.Table;    
        //       }            
        //     }, err => {
        //         this.modal.error(err.message, this.viewref);
        //     });
        // } else {
        //     alert('Please input customer code and branch code');
        // }
    }

    DocNoSelectChange(value: any){

    }

    CheckSearchCondition():boolean{
        let boolHadSelectedCondition : boolean;
        boolHadSelectedCondition = false;//maening: User is not selecting condition search report.
        //check null and undefined
        if(this.ListDataReportCondition.CUSTOMER_CODE == null || this.ListDataReportCondition.CASHEER_NO == null || this.ListDataReportCondition.DOCUMENT_NO == null || this.ListDataReportCondition.C_TOTAL_PAGE <= 0 ){
            boolHadSelectedCondition = false;
        }else{
            boolHadSelectedCondition = true;
        }
    
        // console.log("result Check Search condition: ",boolHadSelectedCondition);
        return boolHadSelectedCondition;
      }//end CheckSearchCondition
    
      // SaveStickerBeforePrint(){
      //   // console.log("Data CUSTOMER_CODE:", this.ListDataReportCondition.CUSTOMER_CODE);
      //   if (!!this.ListDataReportCondition.CUSTOMER_CODE) {
      //       console.log("Data save sticker:", this.ListDataReportCondition);
      //       this.HttpService.post("WH", "SNSR040_SaveStickerBeforePrint", JSON.stringify(this.ListDataReportCondition))
      //       .subscribe(result => {
      //         console.log("result of save sticker: ",result);
                          
      //       }, err => {
      //           this.modal.error(err.message, this.viewref);
      //       });
      //   }
      // }

      OpenReport(){
        if(this.CheckSearchCondition()){
            //save sticker into temp table for report viewer read it.
            //this.SaveStickerBeforePrint();

            //console.log("Sent to Report:",this.ListDataReportCondition);
            this.GoToReport();//show roport viewer.
        }
      }

      GoToReport() {
        // console.log('Show list data report',this.ListDataReportCondition);
        this.global.GoToReport("PMS_RPT_WH_SNSR041_OUM", {  
                                                            //P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                                                            P_CUSTOMER_CODE: this.ListDataReportCondition.CUSTOMER_CODE,
                                                            P_CASHEER_NO: this.ListDataReportCondition.CASHEER_NO,
                                                            P_DOCUMENT_NO: this.ListDataReportCondition.DOCUMENT_NO,
                                                            P_TOTAL_PAGE: this.ListDataReportCondition.C_TOTAL_PAGE
                                                      })
      }
}
