import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import * as moment from 'moment';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'weeklyrep',
    templateUrl: './WEEKLYREP.component.html',
    styleUrls: ['./WEEKLYREP.component.css']
})



export class WEEKLYREPComponent implements OnInit {


    constructor(
        private http: HttpService,
        private global: Globals,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    public currentDate: moment.Moment;
    public countRow: number;

    public ngOnInit() {
        this.currentDate = moment();
    }

    public GetCurrentDate() {
        this.http.GetSystemDate()
          .subscribe(d => {
            this.currentDate = moment(d);
          })
      }

    public RunReport() {
      let currentDate = this.global.ConvertDateToFormatSTD(this.currentDate);
      //console.log(currentDate);
    
        this.http.getParams("SL", ["WEEKLYREP", currentDate], null)
          .subscribe(result => {
            this.modal.info("Generate Weekly reports completed.", this.viewref);
          })
      }

}

